VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmModeChanger 
   Caption         =   "Application Mode Changer"
   ClientHeight    =   3165
   ClientLeft      =   1230
   ClientTop       =   3255
   ClientWidth     =   8475
   LinkTopic       =   "Form1"
   ScaleHeight     =   3165
   ScaleWidth      =   8475
   Begin VB.CommandButton cmdChange 
      Caption         =   "Change &Mode"
      Height          =   315
      Left            =   240
      TabIndex        =   5
      Top             =   2640
      Width           =   1695
   End
   Begin VB.Frame Frame1 
      Caption         =   "Application Mode"
      Height          =   1335
      Left            =   240
      TabIndex        =   2
      Top             =   840
      Width           =   3375
      Begin VB.OptionButton ModeOption 
         Caption         =   "Console Application"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   4
         Top             =   840
         Value           =   -1  'True
         Width           =   1935
      End
      Begin VB.OptionButton ModeOption 
         Caption         =   "GUI Application"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   3
         Top             =   360
         Width           =   1935
      End
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "&Browse..."
      Height          =   315
      Left            =   7200
      TabIndex        =   1
      Top             =   360
      Width           =   975
   End
   Begin VB.TextBox txtFilename 
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   6975
   End
   Begin MSComDlg.CommonDialog OpenDialog 
      Left            =   4560
      Top             =   1440
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
      DefaultExt      =   "mdb"
      DialogTitle     =   "Open Access Filename"
      Filter          =   "Executable Files (*.exe)|*.exe||"
   End
End
Attribute VB_Name = "frmModeChanger"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Application Mode Changer
'Copyright (c) 2002 - 2004 Nir Sofer
'
'Web site: http://nirsoft.mirrorz.com
'
'This small utility allows you to change the mode of an executable file (.exe) from
'GUI mode to console mode and vise versa.
'You can use this utility for creating console applications in Visual Basic environment.
'
'In order to do this, follow the instructions below:
'1. Write a console application in Visual Basic by using API calls
'(You can learn how to do it from my sample project)
'2. Create an executable file from your VB project.
'3. Run this utility, select your executable file, and click the
'"Change Mode" button. Your executable will be switched from GUI mode to console mode.
'
'If you successfully do the above 3 steps, you'll get a real console application !

Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" _
(ByVal lpFileName As String, _
ByVal dwDesiredAccess As Long, _
ByVal dwShareMode As Long, ByVal _
lpSecurityAttributes As Long, _
ByVal dwCreationDisposition As Long, _
ByVal dwFlagsAndAttributes As Long, _
ByVal hTemplateFile As Long) As Long

Private Declare Function CloseHandle Lib "kernel32" _
(ByVal hObject As Long) As Long

Private Declare Function ReadFile Lib "kernel32" _
(ByVal hFile As Long, _
lpBuffer As Any, _
ByVal nNumberOfBytesToRead As Long, _
lpNumberOfBytesRead As Long, _
ByVal lpOverlapped As Long) As Long

Private Declare Function WriteFile Lib "kernel32" _
(ByVal hFile As Long, _
lpBuffer As Any, _
ByVal nNumberOfBytesToWrite As Long, _
lpNumberOfBytesWritten As Long, _
ByVal lpOverlapped As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
(Destination As Any, _
Source As Any, _
ByVal Length As Long)

Private Const INVALID_HANDLE_VALUE = -1
Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const OPEN_EXISTING = 3

Private Declare Function SetFilePointer Lib "kernel32" _
(ByVal hFile As Long, _
ByVal lDistanceToMove As Long, _
lpDistanceToMoveHigh As Long, _
ByVal dwMoveMethod As Long) As Long

Private Const FILE_BEGIN = 0

'Application Modes:
Private Const IMAGE_SUBSYSTEM_WINDOWS_GUI = 2    'GUI Application
Private Const IMAGE_SUBSYSTEM_WINDOWS_CUI = 3    'Console Application

Private Const ERROR_CANNOT_WRITE_FILE = 1
Private Const ERROR_BAD_FILE_FORMAT = 2
Private Const ERROR_CANNOT_READ_FILE = 3
Private Const ERROR_CANNOT_OPEN_FILE = 4

Private Function GetErrorDesc(iError As Integer) As String
    Select Case iError
        Case ERROR_CANNOT_WRITE_FILE
            GetErrorDesc = "Cannot write to the file"
        
        Case ERROR_BAD_FILE_FORMAT
            GetErrorDesc = "Bad file format"
        
        Case ERROR_CANNOT_READ_FILE
            GetErrorDesc = "Cannot read from the file"
        
        Case ERROR_CANNOT_OPEN_FILE
            GetErrorDesc = "Cannot open the file"
    End Select
End Function

Private Sub ChangeMode(sFilename As String, iAppMode As Integer)
    Dim hFile           As Long
    Dim iError          As Integer
    Dim buffer(1024)    As Byte
    Dim lBytesReadWrite As Long
    Dim lPELocation     As Long
    
    'Open the file with Win32 API call
    hFile = CreateFile(sFilename, _
    GENERIC_READ Or GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0)
    If hFile <> INVALID_HANDLE_VALUE Then
        'Read the Dos header.
        If ReadFile(hFile, buffer(0), &H40, lBytesReadWrite, 0) <> 0 Then
            If buffer(0) = &H4D And buffer(1) = &H5A Then
                'Get the location of the portable executable header.
                CopyMemory lPELocation, buffer(&H3C), 4
                If lPELocation = 0 Then
                    iError = ERROR_BAD_FILE_FORMAT
                Else
                    SetFilePointer hFile, lPELocation, ByVal 0, FILE_BEGIN
                    'Read the portable executable signature.
                    If ReadFile(hFile, buffer(0), 2, lBytesReadWrite, 0) <> 0 Then
                        'Check the signature.
                        If buffer(0) = &H50 And buffer(1) = &H45 Then
                            buffer(0) = iAppMode
                            SetFilePointer hFile, lPELocation + &H5C, ByVal 0, FILE_BEGIN
                            'Change the byte in the executable file to the desired application mode.
                            If WriteFile(hFile, buffer(0), 1, lBytesReadWrite, 0) = 0 Then
                                iError = ERROR_CANNOT_WRITE_FILE
                            End If
                            
                        Else
                            iError = ERROR_BAD_FILE_FORMAT
                        End If
                    Else
                        iError = ERROR_CANNOT_READ_FILE
                    End If
                End If
                
            Else
                iError = ERROR_BAD_FILE_FORMAT
            End If
        Else
            iError = ERROR_CANNOT_READ_FILE
        End If
                
        'Close the file
        CloseHandle hFile
    Else
        iError = ERROR_CANNOT_OPEN_FILE
    End If
    
    If iError = 0 Then
        MsgBox "The application mode was successfully changed", vbOKOnly Or vbInformation, ""
    Else
        MsgBox "Error: " & GetErrorDesc(iError), vbOKOnly Or vbExclamation, "Error"
    End If
End Sub

Private Sub cmdBrowse_Click()
    On Error GoTo canceled
    'Show the open dialog.
    OpenDialog.Flags = cdlOFNExplorer Or cdlOFNFileMustExist Or cdlOFNHideReadOnly
    OpenDialog.ShowOpen
    txtFilename.Text = OpenDialog.FileName
    Exit Sub
canceled:

End Sub

Private Sub cmdChange_Click()
    ChangeMode txtFilename.Text, _
    IIf(ModeOption(1).Value, _
    IMAGE_SUBSYSTEM_WINDOWS_GUI, _
    IMAGE_SUBSYSTEM_WINDOWS_CUI)
End Sub

